drc: enable and fix warnings
[pcsx_rearmed.git] / configure
... / ...
CommitLineData
1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
9rm -f config.log
10
11compile_object()
12{
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
27 $CC -E -dD $CFLAGS include/arm_features.h | grep -q "$1" || return 1
28 return 0
29}
30
31check_define_val()
32{
33 $CC -E -dD $CFLAGS include/arm_features.h | grep "$1" | awk '{print $3}'
34 return 0
35}
36
37# setting options to "yes" or "no" will make that choice default,
38# "" means "autodetect".
39
40platform_list="generic pandora maemo caanoo libretro"
41platform="generic"
42builtin_gpu_list="peops unai neon"
43builtin_gpu=""
44sound_driver_list="oss alsa pulseaudio sdl libretro"
45sound_drivers=""
46plugins="plugins/spunull/spunull.so \
47plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
48ram_fixed="no"
49drc_cache_base="no"
50have_armv5=""
51have_armv6=""
52have_armv7=""
53have_arm_neon=""
54have_tslib=""
55have_gles=""
56have_c64x_dsp=""
57enable_dynarec="yes"
58need_sdl="no"
59need_xlib="no"
60need_libpicofe="yes"
61need_warm="no"
62CFLAGS_GLES=""
63LDLIBS_GLES=""
64# these are for known platforms
65optimize_cortexa8="no"
66optimize_arm926ej="no"
67
68# hardcoded stuff
69CC="${CC-${CROSS_COMPILE}gcc}"
70CXX="${CXX-${CROSS_COMPILE}g++}"
71AS="${AS-${CROSS_COMPILE}as}"
72AR="${AS-${CROSS_COMPILE}ar}"
73MAIN_LDLIBS="$LDLIBS -ldl -lm -lpthread"
74config_mak="config.mak"
75
76fail()
77{
78 echo "$@"
79 exit 1
80}
81
82# call during arg parsing, so that cmd line can override platform defaults
83set_platform()
84{
85 platform=$1
86 case "$platform" in
87 generic)
88 ;;
89 pandora)
90 sound_drivers="oss alsa"
91 ram_fixed="yes"
92 drc_cache_base="yes"
93 optimize_cortexa8="yes"
94 have_arm_neon="yes"
95 need_xlib="yes"
96 ;;
97 maemo)
98 ram_fixed="yes"
99 drc_cache_base="yes"
100 optimize_cortexa8="yes"
101 have_arm_neon="yes"
102 ;;
103 caanoo)
104 sound_drivers="oss"
105 ram_fixed="yes"
106 drc_cache_base="yes"
107 optimize_arm926ej="yes"
108 need_warm="yes"
109 ;;
110 libretro)
111 sound_drivers="libretro"
112 need_libpicofe="no"
113 ;;
114 *)
115 fail "unsupported platform: $platform"
116 ;;
117 esac
118}
119
120for opt do
121 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
122 case "$opt" in
123 --help|-h) show_help="yes"
124 ;;
125 --platform=*) set_platform "$optarg"
126 ;;
127 --gpu=*) builtin_gpu="$optarg"
128 ;;
129 --sound-drivers=*) sound_drivers="$optarg"
130 ;;
131 --enable-neon) have_arm_neon="yes"
132 ;;
133 --disable-neon) have_arm_neon="no"
134 ;;
135 --disable-dynarec) enable_dynarec="no"
136 ;;
137 *) echo "ERROR: unknown option $opt"; show_help="yes"
138 ;;
139 esac
140done
141
142if [ "$show_help" = "yes" ]; then
143 echo "options:"
144 echo " --help print this message"
145 echo " --platform=NAME target platform [$platform]"
146 echo " available: $platform_list"
147 echo " --gpu=NAME builtin gpu plugin [guessed]"
148 echo " available: $builtin_gpu_list"
149 echo " --sound-drivers=LIST sound output drivers [guessed]"
150 echo " available: $sound_driver_list"
151 echo " --enable-neon"
152 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
153 echo " --disable-dynarec disable dynamic recompiler"
154 echo " (dynarec is only available and enabled on ARM)"
155 echo "influential environment variables:"
156 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
157 exit 1
158fi
159
160# validate selections
161if [ "x$builtin_gpu" != "x" ]; then
162 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
163 fail "unsupported builtin gpu plugin: $builtin_gpu"
164 fi
165fi
166
167if [ "x$sound_drivers" != "x" ]; then
168 for d in $sound_drivers; do
169 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
170 fail "unsupported sound driver: $sound_driver"
171 fi
172 done
173fi
174
175if [ "$need_libpicofe" = "yes" ]; then
176 if ! test -f "frontend/libpicofe/README"; then
177 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
178 fi
179fi
180
181if [ "$need_warm" = "yes" ]; then
182 if ! test -f "frontend/warm/README"; then
183 fail "wARM is missing, please run 'git submodule init && git submodule update'"
184 fi
185fi
186
187# basic compiler test
188cat > $TMPC <<EOF
189#include <zlib.h>
190int main(void) { return 0; }
191EOF
192if ! compile_binary; then
193 fail "compiler test failed, please check config.log"
194fi
195
196if [ -z "$ARCH" ]; then
197 ARCH=`$CC -dumpmachine | awk -F '-' '{print $1}'`
198fi
199
200case "$ARCH" in
201arm*)
202 # ARM stuff
203 ARCH="arm"
204
205 if [ "$optimize_cortexa8" = "yes" ]; then
206 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
207 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
208 fi
209 if [ "$optimize_arm926ej" = "yes" ]; then
210 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
211 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
212 fi
213
214 if [ "x$have_arm_neon" = "x" ]; then
215 # detect NEON from user-supplied cflags to enable asm code
216 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
217 fi
218 if [ "x$have_armv7" = "x" ]; then
219 if check_define HAVE_ARMV7; then
220 have_armv7="yes"
221 have_armv6="yes"
222 have_armv5="yes"
223 fi
224 fi
225 if [ "x$have_armv6" = "x" ]; then
226 if check_define HAVE_ARMV6; then
227 have_armv6="yes"
228 have_armv5="yes"
229 fi
230 fi
231 if [ "x$have_armv5" = "x" ]; then
232 have_armv5=`check_define HAVE_ARMV5 && echo yes` || true
233 fi
234
235 if [ "x$builtin_gpu" = "x" ]; then
236 if [ "$have_arm_neon" = "yes" ]; then
237 builtin_gpu="neon"
238 elif [ "$have_armv7" != "yes" ]; then
239 # pre-ARMv7 hardware is usually not fast enough for peops
240 builtin_gpu="unai"
241 else
242 builtin_gpu="peops"
243 fi
244 fi
245
246 # automatically set mfpu and mfloat-abi if they are not set
247 if [ "$have_arm_neon" = "yes" ]; then
248 fpu="neon"
249 elif [ "$have_armv6" = "yes" ]; then
250 fpu="vfp"
251 fi
252 if [ "x$fpu" != "x" ]; then
253 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu"
254 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu"
255 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
256 if [ "$floatabi_set_by_gcc" != "yes" ]; then
257 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
258 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
259 fi
260 fi
261
262 # must disable thumb as recompiler can't handle it
263 if check_define __thumb__; then
264 CFLAGS="$CFLAGS -marm"
265 fi
266
267 # warn about common mistakes
268 if [ "$have_armv5" != "yes" ]; then
269 if ! echo "$CFLAGS" | grep -q -- '-mcpu=\|-march='; then
270 echo "Warning: compiling for ARMv4, is that really what you want?"
271 echo "You probably should specify -mcpu= or -march= like this:"
272 echo " CFLAGS=-march=armv6 ./configure ..."
273 fi
274 fi
275 if [ "$have_arm_neon" = "yes" -a "$have_armv7" != "yes" ]; then
276 echo "Warning: compiling for NEON, but not ARMv7?"
277 echo "You probably want to specify -mcpu= or -march= like this:"
278 echo " CFLAGS=-march=armv7-a ./configure ..."
279 fi
280 ;;
281*)
282 # dynarec only available on ARM
283 enable_dynarec="no"
284 ;;
285esac
286
287if [ "x$builtin_gpu" = "x" ]; then
288 builtin_gpu="peops"
289fi
290
291# supposedly we can avoid -fPIC on armv5 for slightly better performace?
292if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
293 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
294fi
295
296if [ "$ram_fixed" = "yes" ]; then
297 CFLAGS="$CFLAGS -DRAM_FIXED"
298fi
299
300case "$platform" in
301generic)
302 need_sdl="yes"
303 ;;
304maemo)
305 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES"
306 ;;
307libretro)
308 CFLAGS="$CFLAGS -fPIC"
309 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
310 ;;
311esac
312
313# header/library presence tests
314check_zlib()
315{
316 cat > $TMPC <<EOF
317 #include <zlib.h>
318 int main(void) { uncompress(0, 0, 0, 0); }
319EOF
320 compile_binary
321}
322
323check_libpng()
324{
325 cat > $TMPC <<EOF
326 #include <png.h>
327 void main() { png_init_io(0, 0); }
328EOF
329 compile_binary
330}
331
332check_oss()
333{
334 cat > $TMPC <<EOF
335 #include <sys/soundcard.h>
336 #include <sys/ioctl.h>
337 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
338EOF
339 compile_binary
340}
341
342check_alsa()
343{
344 cat > $TMPC <<EOF
345 #include <alsa/asoundlib.h>
346 void main() { snd_pcm_open(0, 0, 0, 0); }
347EOF
348 compile_binary "$@"
349}
350
351check_pulseaudio()
352{
353 cat > $TMPC <<EOF
354 #include <pulse/pulseaudio.h>
355 void main() { pa_threaded_mainloop_new(); }
356EOF
357 compile_binary "$@"
358}
359
360check_sdl()
361{
362 cat > $TMPC <<EOF
363 #include <SDL.h>
364 void main() { SDL_OpenAudio(0, 0); }
365EOF
366 compile_binary "$@"
367}
368
369check_xlib_headers()
370{
371 cat > $TMPC <<EOF
372 #include <X11/Xlib.h>
373 void *f() { return XOpenDisplay(0); }
374EOF
375 compile_object "$@"
376}
377
378# see if we have c64_tools for TI C64x DSP
379check_c64_tools()
380{
381 cat > $TMPC <<EOF
382 #include <inc_libc64_mini.h>
383 int f() { return dsp_open(); }
384EOF
385 compile_object "$@"
386}
387
388MAIN_LDLIBS="$MAIN_LDLIBS -lz"
389check_zlib || fail "please install zlib (libz-dev)"
390
391MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
392check_libpng || fail "please install libpng (libpng-dev)"
393
394# find what audio support we can compile
395if [ "x$sound_drivers" = "x" ]; then
396 if check_oss; then sound_drivers="$sound_drivers oss"; fi
397 if check_alsa -lasound; then
398 sound_drivers="$sound_drivers alsa"
399 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
400 fi
401 if check_pulseaudio -lpulse; then
402 sound_drivers="$sound_drivers pulseaudio"
403 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
404 fi
405 if [ "$need_sdl" = "yes" ] || check_sdl `sdl-config --cflags --libs`; then
406 sound_drivers="$sound_drivers sdl"
407 need_sdl="yes"
408 fi
409else
410 if echo $sound_drivers | grep -q "\<oss\>"; then
411 check_oss || fail "oss support is missing"
412 fi
413 if echo $sound_drivers | grep -q "\<alsa\>"; then
414 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
415 check_alsa || fail "please install libasound2-dev"
416 fi
417 if echo $sound_drivers | grep -q "\<pulseaudio\>"; then
418 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
419 check_pulseaudio || fail "pulseaudio support is missing"
420 fi
421fi
422
423if [ "$need_sdl" = "yes" ]; then
424 which sdl-config > /dev/null || \
425 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
426 CFLAGS="$CFLAGS `sdl-config --cflags`"
427 MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS"
428 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
429fi
430
431# check for tslib (only headers needed)
432if [ "x$have_tslib" = "x" ]; then
433 cat > $TMPC <<EOF
434 #include <tslib.h>
435 void test(struct ts_sample sample) {}
436EOF
437 if compile_object; then
438 have_tslib="yes"
439 else
440 have_tslib="no"
441 fi
442fi
443
444# check for VideoCore stuff for Raspberry Pi
445if [ -d /opt/vc/include -a -d /opt/vc/lib ]; then
446 CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/interface/vmcs_host/linux"
447 LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib"
448 if [ -f /opt/vc/lib/libbcm_host.so ]; then
449 LDLIBS_GLES="$LDLIBS_GLES -lbcm_host"
450 fi
451 need_xlib="yes"
452fi
453
454# check for GLES headers
455cat > $TMPC <<EOF
456#include <GLES/gl.h>
457#include <EGL/egl.h>
458int main(void) {
459 return (int)eglGetDisplay( (EGLNativeDisplayType)0 );
460}
461EOF
462if compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then
463 have_gles="yes"
464 LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES"
465elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then
466 have_gles="yes"
467 LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES"
468fi
469
470if check_c64_tools; then
471 have_c64x_dsp="yes"
472fi
473
474if [ "$have_gles" = "yes" ]; then
475 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
476fi
477if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
478 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
479fi
480
481# check for xlib (only headers needed)
482if [ "x$need_xlib" = "xyes" ]; then
483 check_xlib_headers || fail "please install libx11-dev"
484fi
485
486sizeof_long=`check_define_val __SIZEOF_LONG__`
487if [ "x$sizeof_long" = "x4" ]; then
488 CFLAGS="$CFLAGS -D_FILE_OFFSET_BITS=64"
489fi
490
491cat > $TMPC <<EOF
492void test(void *f, void *d) { fread(d, 1, 1, f); }
493EOF
494if compile_object -Wno-unused-result; then
495 CFLAGS="$CFLAGS -Wno-unused-result"
496fi
497
498# short plugin list for display
499for p in $plugins; do
500 p1=`basename $p`
501 plugins_short="$p1 $plugins_short"
502done
503
504# set things that failed to autodetect to "no"
505test "x$have_armv6" != "x" || have_armv6="no"
506test "x$have_armv7" != "x" || have_armv7="no"
507test "x$have_arm_neon" != "x" || have_arm_neon="no"
508test "x$have_gles" != "x" || have_gles="no"
509test "x$have_c64x_dsp" != "x" || have_c64x_dsp="no"
510
511echo "architecture $ARCH"
512echo "platform $platform"
513echo "built-in GPU $builtin_gpu"
514echo "sound drivers $sound_drivers"
515echo "plugins $plugins_short"
516echo "C compiler $CC"
517echo "C compiler flags $CFLAGS"
518echo "libraries $MAIN_LDLIBS"
519echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
520echo "enable dynarec $enable_dynarec"
521if [ "$ARCH" = "arm" ]; then
522 echo "ARMv7 optimizations $have_armv7"
523 echo "enable ARM NEON $have_arm_neon"
524 echo "TI C64x DSP support $have_c64x_dsp"
525fi
526echo "tslib support $have_tslib"
527if [ "$platform" = "generic" ]; then
528 echo "OpenGL ES output $have_gles"
529fi
530
531echo "# Automatically generated by configure" > $config_mak
532printf "# Configured with:" >> $config_mak
533printf " '%s'" "$0" "$@" >> $config_mak
534echo >> $config_mak
535
536echo "CC = $CC" >> $config_mak
537echo "CXX = $CXX" >> $config_mak
538echo "AS = $AS" >> $config_mak
539echo "CFLAGS += $CFLAGS" >> $config_mak
540echo "ASFLAGS += $ASFLAGS" >> $config_mak
541echo "LDFLAGS += $LDFLAGS" >> $config_mak
542echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
543echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
544echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
545echo >> $config_mak
546
547if [ "$platform" = "libretro" ]; then
548 echo "TARGET = libretro.so" >> $config_mak
549fi
550echo "ARCH = $ARCH" >> $config_mak
551echo "PLATFORM = $platform" >> $config_mak
552echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
553echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
554echo "PLUGINS = $plugins" >> $config_mak
555if [ "$have_arm_neon" = "yes" ]; then
556 echo "HAVE_NEON = 1" >> $config_mak
557fi
558if [ "$have_tslib" = "yes" ]; then
559 echo "HAVE_TSLIB = 1" >> $config_mak
560fi
561if [ "$have_gles" = "yes" ]; then
562 echo "HAVE_GLES = 1" >> $config_mak
563 echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak
564 echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak
565fi
566if [ "$enable_dynarec" = "yes" ]; then
567 echo "USE_DYNAREC = 1" >> $config_mak
568fi
569if [ "$drc_cache_base" = "yes" ]; then
570 echo "DRC_CACHE_BASE = 1" >> $config_mak
571fi
572if [ "$have_c64x_dsp" = "yes" ]; then
573 echo "HAVE_C64_TOOLS = 1" >> $config_mak
574fi
575
576# use pandora's skin (for now)
577test -e skin || ln -s frontend/pandora/skin skin
578
579# vim:shiftwidth=2:expandtab